Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.ServiceModel.Activation
Imports System.Collections.Generic
Imports System.Text

Namespace AdvBusinessServices
	<AspNetCompatibilityRequirements(RequirementsMode := AspNetCompatibilityRequirementsMode.Allowed)> _
	Public Class CallService
		Implements ICallService, IUserProfile
		Public Function GetAgentScript(ByVal orderNumber As String) As AgentScript Implements ICallService.GetAgentScript
			Dim greeting As String = DataUtility.GetAgentScript(1)
			Dim script As New AgentScript()
			Dim order As Order = DataUtility.GetOrderByID(orderNumber)
			Dim customer As Customer = DataUtility.GetCustomerByID(order.CustomerID)
			script.CustomerID = customer.CustomerID
			script.Greeting = String.Format(greeting, customer.LastName)
			script.MinRequiredAnswers = 2
			script.QuestionList = DataUtility.GetSecurityQuestions(orderNumber)
			Return script
		End Function

		Public Function GetOrderDetails(ByVal orderNumber As String) As OrderInfo Implements ICallService.GetOrderDetails
			Dim oi As New OrderInfo()
			oi.Order = DataUtility.GetOrderByID(orderNumber)
			oi.Customer = DataUtility.GetCustomerByID(oi.Order.CustomerID)
			Return oi
		End Function


		#Region "IUserProfile Members"

		Public Function GetUser(ByVal userID As String) As User Implements IUserProfile.GetUser
			Return DataUtility.GetUserByID(userID)
		End Function

		#End Region
	End Class
End Namespace
