Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic

Namespace AdvBusinessServices
	Public NotInheritable Class DataUtility
		Private Shared _scriptList As Dictionary(Of Integer, String) = New Dictionary(Of Integer, String)()
		Private Shared _orderList As Dictionary(Of String, Order) = New Dictionary(Of String,Order)()
		Private Shared _customerList As Dictionary(Of Integer, Customer) = New Dictionary(Of Integer,Customer)()
		Private Shared _questionList As Dictionary(Of Integer, SecurityQuestion) = New Dictionary(Of Integer, SecurityQuestion)()
		Private Shared _userList As Dictionary(Of String, User) = New Dictionary(Of String, User)()

		Private Sub New()
		End Sub
		Public Shared Function GetCustomerByID(ByVal customerID As Integer) As Customer
			Return _customerList(customerID)
		End Function
		Public Shared Function GetUserByID(ByVal userID As String) As User
			Return _userList(userID)
		End Function
		Public Shared Function GetSecurityQuestions(ByVal orderNumber As String) As List(Of SecurityQuestion)
			Dim rnd As New Random()
			Dim numQuestions As Integer = rnd.Next(1, 5) 'this will return a random number from 1 to 4
			Dim questions As List(Of SecurityQuestion) = New List(Of SecurityQuestion)()
			Dim order As Order = GetOrderByID(orderNumber)
			Dim customer As Customer = GetCustomerByID(order.CustomerID)

			For i As Integer = 0 To numQuestions - 1
				Dim questionKey As Integer = i + 1
				Dim q As SecurityQuestion = CType(_questionList(questionKey).Clone(), SecurityQuestion)

				Select Case q.AnswerType
					Case 1
						 q.Answer = customer.PhoneNumber
					Case 2
						q.Answer = order.ShipToAddress
					Case 3
						q.Answer = "$" & order.OrderTotal.ToString()
					Case 4
						q.Answer = order.CustomerID.ToString()
					Case Else
				End Select
				questions.Add(q)
			Next i
			Return questions
		End Function

		Public Shared Function GetOrderByID(ByVal orderNumber As String) As Order
			Return _orderList(orderNumber)
		End Function

		Public Shared Function GetAgentScript(ByVal scriptType As Integer) As String
			Return _scriptList(scriptType)
		End Function

		Shared Sub New()
			LoadTestData()
		End Sub

		Private Shared Sub LoadTestData()
			Dim script As String = "Hello Mr. {0}, thank you so much for calling us today. How is your day? [listen to " & "the customer's response] How can I help you? [listen to the response] I will be glad " & "to help you. First, for the security purpose, I need to ask you a few questions..."


			_userList.Add("jc55", New User() With {.UserID="jc55", .RepNumber="jc55", .FirstName="Nancy", .LastName="Davolio", .Role="Agent", .PhoneExtension=5467})
			_userList.Add("bj55", New User() With {.UserID = "bj55", .RepNumber = "bj55", .FirstName = "Andrew", .LastName = "Fuller", .Role = "Agent", .PhoneExtension = 3457})
			_userList.Add("wl55", New User() With {.UserID = "wl55", .RepNumber = "wl55", .FirstName = "Janet", .LastName = "Leverling", .Role = "Supervisor", .PhoneExtension = 3355})

			'build scripts
			_scriptList.Add(1, script)

			'build customer list
			_customerList.Add(12334, New Customer() With {.CustomerID = 12334, .FirstName = "Margaret", .LastName = "Peacock", .PhoneNumber = "(206) 555-8122", .Address = "4110 Old Redmond Rd.	Redmond, WA	98052, USA"})
			_customerList.Add(98673, New Customer() With {.CustomerID = 98673, .FirstName = "Steven", .LastName = "Buchanan", .PhoneNumber = "(71) 555-4848", .Address = "14 Garrett Hill, London, SW1 8JR	UK"})
			_customerList.Add(58764, New Customer() With {.CustomerID = 58764, .FirstName = "Michael", .LastName = "Suyama", .PhoneNumber = "(71) 555-7773", .Address = "Coventry House Miner Rd., London, EC2 7JR	UK"})
			_customerList.Add(27334, New Customer() With {.CustomerID = 27334, .FirstName = "Robert", .LastName = "King", .PhoneNumber = "(71) 555-5598", .Address = "Edgeham Hollow Winchester Way, London,	RG1 9SP	UK"})

			'build order list
			_orderList.Add("39688", New Order() With {.CustomerID = 12334, .Description = "Order for small widgets", .OrderNumber = "39688", .OrderTotal = 99.57, .ShipToAddress = "4110 Old Redmond Rd.	Redmond, WA	98052, USA"})
			_orderList.Add("57754", New Order() With {.CustomerID = 98673, .Description = "Order for a mountain bike", .OrderNumber = "57754", .OrderTotal = 186.86, .ShipToAddress = "14 Garrett Hill, London, SW1 8JR	UK"})
			_orderList.Add("58967", New Order() With {.CustomerID = 58764, .Description = "Order for a tricycle", .OrderNumber = "58967", .OrderTotal = 148.47, .ShipToAddress = "Coventry House Miner Rd., London, EC2 7JR	UK"})
			_orderList.Add("76948", New Order() With {.CustomerID = 27334, .Description = "Order for bicyle tires", .OrderNumber = "76948", .OrderTotal = 10.54, .ShipToAddress = "Edgeham Hollow Winchester Way, London, RG1 9SP	UK"})

			'build question list
			_questionList.Add(1, New SecurityQuestion() With {.QuestionID = 1, .Question = "what is your phone number?", .AnswerType=1, .Answer="{0}"})
			_questionList.Add(2, New SecurityQuestion() With {.QuestionID = 2, .Question = "what is your order address?", .AnswerType = 2, .Answer = "{0}"})
			_questionList.Add(3, New SecurityQuestion() With {.QuestionID = 3, .Question = "what is your order amount?", .AnswerType = 3, .Answer = "{0}"})
			_questionList.Add(4, New SecurityQuestion() With {.QuestionID = 4, .Question = "what is your account number?", .AnswerType = 4, .Answer = "{0}"})
		End Sub
	End Class
End Namespace