Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text

Namespace AdvBusinessServices
	<ServiceContract> _
	Public Interface ICallService
		<OperationContract> _
		Function GetAgentScript(ByVal orderNumber As String) As AgentScript
		<OperationContract> _
		Function GetOrderDetails(ByVal orderNumber As String) As OrderInfo
	End Interface

	<ServiceContract> _
	Public Interface IUserProfile
		<OperationContract> _
		Function GetUser(ByVal userID As String) As User
	End Interface

	<DataContract> _
	Public Class MessageEntity
		<DataMember> _
		Private ServiceVersion As Double = 1.1
	End Class
	<DataContract> _
	Public Class AgentScript
		Inherits MessageEntity
		<DataMember> _
		Public CustomerID As Integer
		<DataMember> _
		Public Greeting As String
		<DataMember> _
		Public MinRequiredAnswers As Integer
		<DataMember> _
		Public QuestionList As List(Of SecurityQuestion)
	End Class

	<DataContract> _
	Public Class SecurityQuestion
		Inherits MessageEntity
		<DataMember> _
		Public QuestionID As Integer
		<DataMember> _
		Public Question As String
		<DataMember> _
		Public AnswerType As Integer
		<DataMember> _
		Public Answer As String
		<DataMember> _
		Public IsAnswered As Boolean
		Public Function Clone() As SecurityQuestion
			Return CType(Me.MemberwiseClone(), SecurityQuestion)
		End Function
	End Class

	<DataContract> _
	Public Class User
		Inherits MessageEntity
		<DataMember> _
		Public UserID As String
		<DataMember> _
		Public FirstName As String
		<DataMember> _
		Public LastName As String
		<DataMember> _
		Public RepNumber As String
		<DataMember> _
		Public Role As String
		<DataMember> _
		Public PhoneExtension As Integer
	End Class

	<DataContract> _
	Public Class Order
		Inherits MessageEntity
		<DataMember> _
		Public CustomerID As Integer
		<DataMember> _
		Public OrderNumber As String
		<DataMember> _
		Public Description As String
		<DataMember> _
		Public OrderTotal As Double
		<DataMember> _
		Public ShipToAddress As String

	End Class

	<DataContract> _
	Public Class Customer
		Inherits MessageEntity
		<DataMember> _
		Public CustomerID As Integer
		<DataMember> _
		Public FirstName As String
		<DataMember> _
		Public LastName As String
		<DataMember> _
		Public PhoneNumber As String
		<DataMember> _
		Public Address As String
	End Class

	<DataContract> _
	Public Class OrderInfo
		Inherits MessageEntity
		<DataMember> _
		Public Order As Order
		<DataMember> _
		Public Customer As Customer
	End Class


End Namespace
