Imports Microsoft.VisualBasic
Imports System
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Ink
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports ClientEntities=AdvClientLibrary.ClientEntities
Imports System.Collections.Generic
Imports AdvClientLibrary

Namespace AdvCallCenterClient
	Public Class SvcOrderToClientOrder
		Inherits ClientEntityTranslator
		'singleton
		Public Shared entityTranslator As ClientEntityTranslator = New SvcOrderToClientOrder()
		Private Sub New()
		End Sub
		Public Overrides Function ToClientEntity(ByVal serviceOutputEntity As Object) As ClientEntities.ClientEntity
			Dim oi As CallBusinessProxy.OrderInfo = TryCast(serviceOutputEntity, CallBusinessProxy.OrderInfo)
			Dim bindableOrder As New ClientEntities.Order()
			bindableOrder.OrderNumber = oi.Order.OrderNumber
			bindableOrder.OrderTotal = oi.Order.OrderTotal
			bindableOrder.ShipToAddress = oi.Order.ShipToAddress
			bindableOrder.Description = oi.Order.Description
			bindableOrder.CustomerID = oi.Customer.CustomerID
			Return bindableOrder
		End Function
	End Class

	Public Class SvcUserToClientUser
		Inherits ClientEntityTranslator
		'singleton
		Public Shared entityTranslator As ClientEntityTranslator = New SvcUserToClientUser()
		Private Sub New()
		End Sub
		Public Overrides Function ToClientEntity(ByVal serviceOutputEntity As Object) As ClientEntities.ClientEntity
			Dim user As New ClientEntities.User()
			Dim _serviceOutputUser As CallBusinessProxy.User = TryCast(serviceOutputEntity, CallBusinessProxy.User)
			user.Name = _serviceOutputUser.FirstName & " " & _serviceOutputUser.LastName
			user.RepNumber = _serviceOutputUser.RepNumber
			user.UserID = _serviceOutputUser.UserID
			user.Role = _serviceOutputUser.Role
			user.PhoneExtension = _serviceOutputUser.PhoneExtension

			Return user
		End Function
	End Class

	Public Class SvcScriptToClientScript
		Inherits ClientEntityTranslator
		'singleton
		Public Shared entityTranslator As ClientEntityTranslator = New SvcScriptToClientScript()
		Private Sub New()
		End Sub
		Public Overrides Function ToClientEntity(ByVal serviceOutputEntity As Object) As ClientEntities.ClientEntity
			Dim agentScript As New ClientEntities.AgentScript()
			Dim serviceOutputAgentScript As CallBusinessProxy.AgentScript = TryCast(serviceOutputEntity, CallBusinessProxy.AgentScript)
			agentScript.CustomerID = serviceOutputAgentScript.CustomerID
			agentScript.Greeting = serviceOutputAgentScript.Greeting
			agentScript.QuestionList = New List(Of ClientEntities.SecurityQuestion)()
			For Each s As CallBusinessProxy.SecurityQuestion In serviceOutputAgentScript.QuestionList
				Dim sc As New ClientEntities.SecurityQuestion()
				sc.Answer = s.Answer
				sc.AnswerType = s.AnswerType
				sc.IsAnswered = False
				sc.Question = s.Question
				sc.QuestionID = s.QuestionID
				agentScript.QuestionList.Add(sc)
			Next s
			Return agentScript
		End Function
	End Class
End Namespace
