Imports Microsoft.VisualBasic
Imports System
Imports System.Threading
Imports System.Windows
Imports System.Windows.Controls
Imports AdvCallCenterClient.CallBusinessProxy
Imports AdvClientLibrary
Imports SilverlightPopups
Imports TcpMessages
Imports ClientEntities = AdvClientLibrary.ClientEntities
Imports System.Net
Imports System.IO
Imports System.Reflection

Namespace AdvCallCenterClient
    Partial Public Class Page
        Inherits UserControl
        Private _orderDetailContol As UserControl
        Private _orderDetailDownloadHandle As New SLManualResetEvent(False)
        Public Sub New()
            InitializeComponent()
            ClientGlobals.socketClient = New CallNetworkClient()
            AddHandler ClientGlobals.socketClient.OnReceive, AddressOf ReceiveCallback
            AddHandler ClientGlobals.socketClient.OnConnectError, AddressOf _socketClient_OnConnectError
            ClientGlobals.socketClient.Connect(4530)
            ClientGlobals.networkPopup = New CommunicationPopup(Me, "Send in progress...")
            ClientGlobals.notifyCallPopup = New NotifyCallPopup(Me, "Incoming call...")
            AddHandler ClientGlobals.notifyCallPopup.OnAccept, AddressOf _notifyCallPopup_OnAccept
            AddHandler ClientGlobals.notifyCallPopup.OnReject, AddressOf _notifyCallPopup_OnReject
            ClientGlobals.repInfo = New ClientEntities.CallRep()
        End Sub

        Private Sub _notifyCallPopup_OnReject(ByVal sender As Object, ByVal e As EventArgs)
            Dim rejectMsg As New RepKeyMessage(MessageAction.Reject)
            rejectMsg.RepNumber = ClientGlobals.currentUser.RepNumber
            ClientGlobals.socketClient.SendAsync(rejectMsg)
        End Sub

        Private Sub _notifyCallPopup_OnAccept(ByVal sender As Object, ByVal e As EventArgs)
            Dim acceptMsg As New RepKeyMessage(MessageAction.Accept)
            acceptMsg.RepNumber = ClientGlobals.currentUser.RepNumber
            ClientGlobals.socketClient.SendAsync(acceptMsg)
            Me.borderCallProgressView.DataContext = ClientGlobals.callInfo
            Dim callService As ICallService = New CallServiceClient()
            Dim result As IAsyncResult = callService.BeginGetAgentScript(ClientGlobals.callInfo.OrderNumber, AddressOf GetAgentScriptCallback, callService)
            'do a preemptive download of user control
            ThreadPool.QueueUserWorkItem(AddressOf ExecuteControlDownload)
            'do a preemptive download of the order information
            ThreadPool.QueueUserWorkItem(AddressOf ExecuteGetOrderDetails, ClientGlobals.callInfo.OrderNumber)

        End Sub

        Private Sub GetAgentScriptCallback(ByVal asyncReseult As IAsyncResult)
            Dim callService As ICallService = TryCast(asyncReseult.AsyncState, ICallService)
            Dim svcOutputAgentScript As CallBusinessProxy.AgentScript = callService.EndGetAgentScript(asyncReseult)
            Dim astobas As ClientEntityTranslator = SvcScriptToClientScript.entityTranslator
            Dim currentAgentScript As ClientEntities.AgentScript = TryCast(astobas.ToClientEntity(svcOutputAgentScript), ClientEntities.AgentScript)
            Interlocked.Exchange(Of ClientEntities.AgentScript)(ClientGlobals.currentAgentScript, currentAgentScript)
            If Me.Dispatcher.CheckAccess() Then
                Me.borderAgentScript.DataContext = ClientGlobals.currentAgentScript
                'this.gridSecurityQuestions.DataContext = ClientGlobals.agentScript.QuestionList;
                Me.gridSecurityQuestions.ItemsSource = ClientGlobals.currentAgentScript.QuestionList
                Me.borderWaitView.Visibility = Visibility.Collapsed
                Me.hlEndCall.Visibility = Visibility.Collapsed
                Me.borderCallProgressView.Visibility = Visibility.Visible
                Me.gridSecurityQuestions.Visibility = Visibility.Visible
                Me.borderAgentScript.Visibility = Visibility.Visible
                Me.hlVerifyContinue.Visibility = Visibility.Visible
            Else
                'this.gridSecurityQuestions.ItemsSource = ClientGlobals.agentScript.QuestionList;
                Me.Dispatcher.BeginInvoke(AddressOf AnonymousMethod1)
            End If
        End Sub
        Private Sub AnonymousMethod1()
            Me.borderAgentScript.DataContext = ClientGlobals.currentAgentScript
            Me.gridSecurityQuestions.DataContext = ClientGlobals.currentAgentScript.QuestionList
            Me.borderWaitView.Visibility = Visibility.Collapsed
            Me.hlEndCall.Visibility = Visibility.Collapsed
            Me.borderCallProgressView.Visibility = Visibility.Visible
            Me.gridSecurityQuestions.Visibility = Visibility.Visible
            Me.borderAgentScript.Visibility = Visibility.Visible
            Me.hlVerifyContinue.Visibility = Visibility.Visible
        End Sub

        Private Sub _socketClient_OnConnectError(ByVal sender As Object, ByVal e As EventArgs)
            Me.tbStatus.Dispatcher.BeginInvoke(Function() Me.tbStatus.Text = "Connect error...")
        End Sub

        Private Sub ReceiveCallback(ByVal sender As Object, ByVal e As ReceiveArgs)
            Dim msg As NetworkMessage = e.Result
            ProcessMessage(msg)
        End Sub

        Private Sub buttonSubmit_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
            ClientGlobals.repInfo.ShiftStartTime = DateTime.Now
            Dim registerMsg As New RegisterMessage(MessageAction.Register)
            registerMsg.RepName = ClientGlobals.currentUser.Name
            registerMsg.RepNumber = ClientGlobals.currentUser.RepNumber
            registerMsg.PhoneExtension = ClientGlobals.currentUser.PhoneExtension
            ClientGlobals.networkPopup.ShowDialog(True)
            ClientGlobals.socketClient.SendAsync(registerMsg)
        End Sub

        Private Sub Page_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Me.ctrlLoginView.Visibility = Visibility.Visible

        End Sub
        Private Sub ProcessMessage(ByVal msg As NetworkMessage)
            'switch(msg.GetMessageType())
            Select Case msg.Action
                'case MessageType.RegisterResponse:
                Case MessageAction.RegisterResponse
                    Dim respMsg As RegisterResponse = TryCast(msg, RegisterResponse)
                    'check if the code is executing on the UI thread
                    'the if is unncessary as the code always executes in the background thread
                    If (Not Me.Dispatcher.CheckAccess()) Then
                        'the following Sleep is only meant to show the popup long enough
                        'during demos; remove for real use
                        System.Threading.Thread.Sleep(1000)
                        'do databinding here
                        Dim onSetupFormValues As New Action(Of RegisterResponse)(AddressOf SetupFormValues)
                        Me.Dispatcher.BeginInvoke(onSetupFormValues, respMsg)
                        SetupFormValues(respMsg)
                    End If
                    'case MessageType.Call:
                Case MessageAction.Call
                    Dim callMsg As CallMessage = TryCast(msg, CallMessage)
                    Dim currentCallInfo As New ClientEntities.PhoneCall()
                    currentCallInfo.Name = callMsg.CallerName
                    currentCallInfo.PhoneNumber = callMsg.CallerPhone
                    currentCallInfo.OrderNumber = callMsg.IvrData
                    Interlocked.Exchange(Of ClientEntities.PhoneCall)(ClientGlobals.callInfo, currentCallInfo)
                    If (Not Me.Dispatcher.CheckAccess()) Then
                        Me.Dispatcher.BeginInvoke(AddressOf ShowNotifyCallPopupDialog)
                    End If
                Case Else
            End Select
        End Sub

        Private Sub ShowNotifyCallPopupDialog()
            ClientGlobals.notifyCallPopup.ShowDialog(True)
        End Sub


        Private Sub SetupFormValues(ByVal respMsg As RegisterResponse)

            ClientGlobals.networkPopup.CloseDialog()
            Me.registrationView.Visibility = Visibility.Collapsed
            Me.callView.Visibility = Visibility.Visible
            Me.borderWaitView.Visibility = Visibility.Visible
            Me.tbRepDisplayName.Text = Me.txRepName.Text
            Me.tbRepDisplayNumber.Text = respMsg.RepNumber
            Me.tbCallServerName.Text = respMsg.CallManagerServerName
            Dim ts As DateTime = respMsg.RegistrationTimestamp
            Me.tbCallStartTime.Text = String.Format("{0:D2}/{1:D2}/{2:D4} {3:D2}:{4:D2}:{5:D2}", ts.Month, ts.Day, ts.Year, ts.Hour, ts.Minute, ts.Second)
        End Sub

        Private Sub hlVerifyContinue_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Me.gridSecurityQuestions.Visibility = Visibility.Collapsed
            'if the control is not instandiated, add it to the control tree
            If _orderDetailContol Is Nothing Then
                _orderDetailContol = TryCast(ClientGlobals.advOrderControls_dll.CreateInstance("AdvOrderClientControls.OrderDetail"), UserControl)
                spCallProgressPanel.Children.Add(_orderDetailContol)
            End If
            _orderDetailContol.DataContext = ClientGlobals.currentOrder
            borderCall.Visibility = Visibility.Collapsed
            borderAgentScript.Visibility = Visibility.Collapsed
            hlVerifyContinue.Visibility = Visibility.Collapsed
            hlEndCall.Visibility = Visibility.Visible
            _orderDetailContol.Visibility = Visibility.Visible

        End Sub

        Private Sub ExecuteControlDownload(ByVal state As Object)
            Dim webClient As New WebClient()
            AddHandler webClient.OpenReadCompleted, AddressOf OrderDetailControlDownloadCallback
            webClient.OpenReadAsync(New Uri("/ClientBin/AdvOrderClientControls.dll", UriKind.Relative))
        End Sub

        Private Sub OrderDetailControlDownloadCallback(ByVal sender As Object, ByVal e As OpenReadCompletedEventArgs)
            Try
                'if there is a problem with the download the following statement will through an exception
                Dim downloadedStream As Stream = e.Result
                Dim onDownloadCallBackAction As New Action(Of Stream)(AddressOf OnDownloadCallBack)
                Me.Dispatcher.BeginInvoke(onDownloadCallBackAction)
                OnDownloadCallBack(downloadedStream)
            Catch
                Throw New SLApplicationException("Download of OrderDetail control failed")
            End Try
        End Sub

        Private Sub OnDownloadCallBack(ByVal downloadedStream As Stream)

            Dim asm As System.Reflection.Assembly = ResourceUtility.GetAssembly(downloadedStream)
            Interlocked.Exchange(Of System.Reflection.Assembly)(ClientGlobals.advOrderControls_dll, asm)
        End Sub

        Private Sub ExecuteGetOrderDetails(ByVal state As Object)
            Dim client As New CallServiceClient()
            Dim orderNumber As String = TryCast(state, String)
            AddHandler client.GetOrderDetailsCompleted, AddressOf GetOrderDetailsCompletedCallback
            client.GetOrderDetailsAsync(orderNumber)
            Me._orderDetailDownloadHandle.Reset()
            Me._orderDetailDownloadHandle.WaitOne()
            Dim oito As ClientEntityTranslator = SvcOrderToClientOrder.entityTranslator
            Dim currentOrder As ClientEntities.Order = CType(oito.ToClientEntity(ClientGlobals.serviceOutputOrder), ClientEntities.Order)
            Interlocked.Exchange(Of ClientEntities.Order)(ClientGlobals.currentOrder, currentOrder)
        End Sub

        Private Sub GetOrderDetailsCompletedCallback(ByVal sender As Object, ByVal e As GetOrderDetailsCompletedEventArgs)
            Interlocked.Exchange(Of OrderInfo)(ClientGlobals.serviceOutputOrder, e.Result)
            'this._orderDetailDownloadHandle.Set();
            Me._orderDetailDownloadHandle.Set()

        End Sub

        Private Sub hlEndCall_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
            borderCallProgressView.Visibility = Visibility.Collapsed
            _orderDetailContol.Visibility = Visibility.Collapsed
            borderWaitView.Visibility = Visibility.Visible
            ClientGlobals.repInfo.NoOfCallsServiced += 1
            Me.tbNumCalls.Text = ClientGlobals.repInfo.NoOfCallsServiced.ToString()
            Dim finishCallMsg As New RepKeyMessage(MessageAction.FinishCall)
            finishCallMsg.RepNumber = ClientGlobals.currentUser.RepNumber
            ClientGlobals.callInfo = Nothing
            ClientGlobals.currentAgentScript = Nothing
            ClientGlobals.currentOrder = Nothing
            ClientGlobals.serviceOutputOrder = Nothing
            ClientGlobals.socketClient.SendAsync(finishCallMsg)
        End Sub

        Private Sub ctrlLoginView_OnSuccessfulLogin(ByVal sender As Object, ByVal e As EventArgs)
            Dim login As Login = TryCast(sender, Login)
            Dim userProfile As New CallBusinessProxy.UserProfileClient()
            AddHandler userProfile.GetUserCompleted, AddressOf GetUserCompletedCallback
            userProfile.GetUserAsync(login.txRepID.Text)
        End Sub

        Private Sub GetUserCompletedCallback(ByVal sender As Object, ByVal e As GetUserCompletedEventArgs)
            Dim serviceOutputUser As CallBusinessProxy.User = e.Result
            Dim utbu As ClientEntityTranslator = SvcUserToClientUser.entityTranslator
            Dim currentUser As ClientEntities.User = TryCast(utbu.ToClientEntity(serviceOutputUser), ClientEntities.User)
            Interlocked.Exchange(Of ClientEntities.User)(ClientGlobals.currentUser, currentUser)
            If Me.Dispatcher.CheckAccess() Then
                Me.registrationView.DataContext = ClientGlobals.currentUser
                Me.ctrlLoginView.Visibility = Visibility.Collapsed
                Me.registrationView.Visibility = Visibility.Visible
                Me.buttonSubmit.IsEnabled = True
            Else
                Me.Dispatcher.BeginInvoke(AddressOf AnonymousMethod2)
            End If
        End Sub
        Private Sub AnonymousMethod2()
            Me.registrationView.DataContext = ClientGlobals.currentUser
            Me.ctrlLoginView.Visibility = Visibility.Collapsed
            Me.registrationView.Visibility = Visibility.Visible
            Me.buttonSubmit.IsEnabled = True
        End Sub
    End Class
End Namespace
