Imports Microsoft.VisualBasic
Imports System
Imports System.IO
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Namespace AdvCallManager
	Friend Class PhoneCall
		Public Name As String
		Public PhoneNumber As String
		Public OrderNumber As String
	End Class

	Friend Class CallRep
		Public Sub New(ByVal repCon As RepConnection)
			RepConnection = repCon
		End Sub
		'encasulates network connection associated with the registered call center rep
		Private privateRepConnection As RepConnection
		Public Property RepConnection() As RepConnection
			Get
				Return privateRepConnection
			End Get
			Set(ByVal value As RepConnection)
				privateRepConnection = value
			End Set
		End Property
		'uniquely identifies the rep
		Private privateRepNumber As String
		Public Property RepNumber() As String
			Get
				Return privateRepNumber
			End Get
			Set(ByVal value As String)
				privateRepNumber = value
			End Set
		End Property
		Private privateRepName As String
		Public Property RepName() As String
			Get
				Return privateRepName
			End Get
			Set(ByVal value As String)
				privateRepName = value
			End Set
		End Property
		Private privatePhoneExtension As Integer
		Public Property PhoneExtension() As Integer
			Get
				Return privatePhoneExtension
			End Get
			Set(ByVal value As Integer)
				privatePhoneExtension = value
			End Set
		End Property
		Private privateShiftStartTime As DateTime
		Public Property ShiftStartTime() As DateTime
			Get
				Return privateShiftStartTime
			End Get
			Set(ByVal value As DateTime)
				privateShiftStartTime = value
			End Set
		End Property
		Private privateShiftEndTime As DateTime
		Public Property ShiftEndTime() As DateTime
			Get
				Return privateShiftEndTime
			End Get
			Set(ByVal value As DateTime)
				privateShiftEndTime = value
			End Set
		End Property
		'MaxValue indicates haven't rejected any calls
		Private privateLastRejectTime As DateTime
		Public Property LastRejectTime() As DateTime
			Get
				Return privateLastRejectTime
			End Get
			Set(ByVal value As DateTime)
				privateLastRejectTime = value
			End Set
		End Property
		'Available will false if the rep is servicing the call
		Private privateAvailable As Boolean
		Public Property Available() As Boolean
			Get
				Return privateAvailable
			End Get
			Set(ByVal value As Boolean)
				privateAvailable = value
			End Set
		End Property
		'Locked field will be set to true when a call notification is sent.
		'A background thread will clear it if the rep does not reject or accept 
		'the call notification
		Private privateLocked As Boolean
		Public Property Locked() As Boolean
			Get
				Return privateLocked
			End Get
			Set(ByVal value As Boolean)
				privateLocked = value
			End Set
		End Property
		'The background thread will use the LockTime + a configurable amount of minutes
		'to free the rep 
		Private privateLockTime As DateTime
		Public Property LockTime() As DateTime
			Get
				Return privateLockTime
			End Get
			Set(ByVal value As DateTime)
				privateLockTime = value
			End Set
		End Property
		Public NoOfCallsServiced As Integer 'during the current shift
	End Class
End Namespace