Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic

Namespace AdvClientLibrary.ClientEntities
	'marker entity
	Public MustInherit Class ClientEntity
	End Class
	Public Class PhoneCall
		Inherits ClientEntity
		Private privateName As String
		Public Property Name() As String
			Get
				Return privateName
			End Get
			Set(ByVal value As String)
				privateName = value
			End Set
		End Property
		Private privatePhoneNumber As String
		Public Property PhoneNumber() As String
			Get
				Return privatePhoneNumber
			End Get
			Set(ByVal value As String)
				privatePhoneNumber = value
			End Set
		End Property
		Private privateOrderNumber As String
		Public Property OrderNumber() As String
			Get
				Return privateOrderNumber
			End Get
			Set(ByVal value As String)
				privateOrderNumber = value
			End Set
		End Property
	End Class
	Public Class Order
		Inherits ClientEntity
		Private privateCustomerID As Integer
		Public Property CustomerID() As Integer
			Get
				Return privateCustomerID
			End Get
			Set(ByVal value As Integer)
				privateCustomerID = value
			End Set
		End Property
		Private privateOrderNumber As String
		Public Property OrderNumber() As String
			Get
				Return privateOrderNumber
			End Get
			Set(ByVal value As String)
				privateOrderNumber = value
			End Set
		End Property
		Private privateDescription As String
		Public Property Description() As String
			Get
				Return privateDescription
			End Get
			Set(ByVal value As String)
				privateDescription = value
			End Set
		End Property
		Private privateOrderTotal As Double
		Public Property OrderTotal() As Double
			Get
				Return privateOrderTotal
			End Get
			Set(ByVal value As Double)
				privateOrderTotal = value
			End Set
		End Property
		Private privateShipToAddress As String
		Public Property ShipToAddress() As String
			Get
				Return privateShipToAddress
			End Get
			Set(ByVal value As String)
				privateShipToAddress = value
			End Set
		End Property
	End Class

	Public Class User
		Inherits ClientEntity
		Private privateUserID As String
		Public Property UserID() As String
			Get
				Return privateUserID
			End Get
			Set(ByVal value As String)
				privateUserID = value
			End Set
		End Property
		Private privateName As String
		Public Property Name() As String
			Get
				Return privateName
			End Get
			Set(ByVal value As String)
				privateName = value
			End Set
		End Property
		Private privateRepNumber As String
		Public Property RepNumber() As String
			Get
				Return privateRepNumber
			End Get
			Set(ByVal value As String)
				privateRepNumber = value
			End Set
		End Property
		Private privateRole As String
		Public Property Role() As String
			Get
				Return privateRole
			End Get
			Set(ByVal value As String)
				privateRole = value
			End Set
		End Property
		Private privatePhoneExtension As Integer
		Public Property PhoneExtension() As Integer
			Get
				Return privatePhoneExtension
			End Get
			Set(ByVal value As Integer)
				privatePhoneExtension = value
			End Set
		End Property
	End Class

	Public Class CallRep
		Inherits ClientEntity
		Private privateShiftStartTime As DateTime
		Public Property ShiftStartTime() As DateTime
			Get
				Return privateShiftStartTime
			End Get
			Set(ByVal value As DateTime)
				privateShiftStartTime = value
			End Set
		End Property
		Private privateShiftEndTime As DateTime
		Public Property ShiftEndTime() As DateTime
			Get
				Return privateShiftEndTime
			End Get
			Set(ByVal value As DateTime)
				privateShiftEndTime = value
			End Set
		End Property
		'MaxValue indicates haven't rejected any calls
		Private privateLastRejectTime As DateTime
		Public Property LastRejectTime() As DateTime
			Get
				Return privateLastRejectTime
			End Get
			Set(ByVal value As DateTime)
				privateLastRejectTime = value
			End Set
		End Property
		'Available will be set to false if a rep accepts the call
		Private privateNoOfCallsServiced As Integer
		Public Property NoOfCallsServiced() As Integer
			Get
				Return privateNoOfCallsServiced
			End Get
			Set(ByVal value As Integer)
				privateNoOfCallsServiced = value
			End Set
		End Property
		Private privateAverageServiceDuration As Integer
		Public Property AverageServiceDuration() As Integer
			Get
				Return privateAverageServiceDuration
			End Get
			Set(ByVal value As Integer)
				privateAverageServiceDuration = value
			End Set
		End Property
	End Class

	Public Class AgentScript
		Inherits ClientEntity
		Private privateCustomerID As Integer
		Public Property CustomerID() As Integer
			Get
				Return privateCustomerID
			End Get
			Set(ByVal value As Integer)
				privateCustomerID = value
			End Set
		End Property
		Private privateGreeting As String
		Public Property Greeting() As String
			Get
				Return privateGreeting
			End Get
			Set(ByVal value As String)
				privateGreeting = value
			End Set
		End Property
		Private privateMinRequiredAnswers As Integer
		Public Property MinRequiredAnswers() As Integer
			Get
				Return privateMinRequiredAnswers
			End Get
			Set(ByVal value As Integer)
				privateMinRequiredAnswers = value
			End Set
		End Property
		Private privateQuestionList As List(Of SecurityQuestion)
		Public Property QuestionList() As List(Of SecurityQuestion)
			Get
				Return privateQuestionList
			End Get
			Set(ByVal value As List(Of SecurityQuestion))
				privateQuestionList = value
			End Set
		End Property
	End Class
	Public Class SecurityQuestion
		Private privateQuestionID As Integer
		Public Property QuestionID() As Integer
			Get
				Return privateQuestionID
			End Get
			Set(ByVal value As Integer)
				privateQuestionID = value
			End Set
		End Property
		Private privateQuestion As String
		Public Property Question() As String
			Get
				Return privateQuestion
			End Get
			Set(ByVal value As String)
				privateQuestion = value
			End Set
		End Property
		Private privateAnswerType As Integer
		Public Property AnswerType() As Integer
			Get
				Return privateAnswerType
			End Get
			Set(ByVal value As Integer)
				privateAnswerType = value
			End Set
		End Property
		Private privateAnswer As String
		Public Property Answer() As String
			Get
				Return privateAnswer
			End Get
			Set(ByVal value As String)
				privateAnswer = value
			End Set
		End Property
		Private privateIsAnswered As Boolean
		Public Property IsAnswered() As Boolean
			Get
				Return privateIsAnswered
			End Get
			Set(ByVal value As Boolean)
				privateIsAnswered = value
			End Set
		End Property
	End Class
End Namespace
