Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Controls.Primitives

Namespace SilverlightPopups
	Public MustInherit Class SLDialogBox
		Protected _popup As New Popup()
		Protected _parent As Control = Nothing
		Protected _caption As String = String.Empty
		Public MustOverride Function GetControlTree() As UIElement
		Public MustOverride Sub WireHandlers()
		Public MustOverride Sub WireUI()
		Public Sub New(ByVal parent As Control, ByVal caption As String)
			_parent = parent
			_caption = caption
			_popup.Child = GetControlTree()
			WireUI()
			WireHandlers()
			AdjustPostion()

		End Sub
		Public Sub ShowDialog(ByVal isModal As Boolean)
			If _popup.IsOpen Then
				Return
			End If
			_popup.IsOpen = True
			CType(_parent, UserControl).IsEnabled = False
		End Sub
		Public Sub CloseDialog()
			If (Not _popup.IsOpen) Then
				Return
			End If
			_popup.IsOpen = False
			CType(_parent, UserControl).IsEnabled = True
		End Sub
		Private Sub AdjustPostion()
			Dim parentUC As UserControl = TryCast(_parent, UserControl)
			If parentUC Is Nothing Then
				Return
			End If

			Dim popupElement As FrameworkElement = TryCast(_popup.Child, FrameworkElement)
			If popupElement Is Nothing Then
				Return
			End If

			Dim left As Double = (parentUC.Width - popupElement.Width) / 2
			Dim top As Double = (parentUC.Height - popupElement.Height) / 2
			_popup.Margin = New Thickness(left, top, left, top)
		End Sub
	End Class
End Namespace
