Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports AdvClientLibrary

Namespace SilverlightPopups
	Public Class CommunicationPopup
		Inherits SLDialogBox
		Public Event OnCancel As EventHandler(Of EventArgs)
		Public Sub New(ByVal parent As Control, ByVal msg As String)
			MyBase.New(parent, msg)

		End Sub
		Public Overrides Function GetControlTree() As UIElement
			Return ResourceUtility.GetUIElementFromXaml("CommunicationPopup.xaml")
		End Function
		Public Overrides Sub WireUI()
			Dim fe As FrameworkElement = CType(_popup.Child, FrameworkElement)
			Dim btCaption As TextBlock = TryCast(fe.FindName("tbCaption"), TextBlock)
			If btCaption IsNot Nothing Then
				btCaption.Text = _caption
			End If
		End Sub
		Public Overrides Sub WireHandlers()
			Dim fe As FrameworkElement = CType(_popup.Child, FrameworkElement)
			Dim btCancel As Button = CType(fe.FindName("btCancel"), Button)
			AddHandler btCancel.Click, AddressOf btCancel_Click
		End Sub

		Private Sub btCancel_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			CloseDialog()
			RaiseEvent OnCancel(Me, Nothing)

		End Sub
	End Class

	Public Class NotifyCallPopup
		Inherits SLDialogBox
		Public Event OnAccept As EventHandler(Of EventArgs)
		Public Event OnReject As EventHandler(Of EventArgs)
		Public Sub New(ByVal parent As Control, ByVal msg As String)
			MyBase.New(parent, msg)

		End Sub
		Public Overrides Function GetControlTree() As UIElement
			Return ResourceUtility.GetUIElementFromXaml("NotifyCallPopup.xaml")
		End Function
		Public Overrides Sub WireUI()
			Dim fe As FrameworkElement = CType(_popup.Child, FrameworkElement)
			Dim btCaption As TextBlock = TryCast(fe.FindName("tbCaption"), TextBlock)
			If btCaption IsNot Nothing Then
				btCaption.Text = _caption
			End If
		End Sub
		Public Overrides Sub WireHandlers()
			Dim fe As FrameworkElement = CType(_popup.Child, FrameworkElement)
			Dim btAccept As Button = CType(fe.FindName("btAccept"), Button)
			AddHandler btAccept.Click, AddressOf btAccept_Click

			Dim btReject As Button = CType(fe.FindName("btReject"), Button)
			AddHandler btReject.Click, AddressOf btReject_Click

		End Sub

		Private Sub btAccept_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			CloseDialog()
			RaiseEvent OnAccept(Me, Nothing)
		End Sub
		Private Sub btReject_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			CloseDialog()
			RaiseEvent OnReject(Me, Nothing)
		End Sub
	End Class
	Public Class OkPopup
		Inherits SLDialogBox
		Public Event OnOk As EventHandler(Of EventArgs)
		Public Sub New(ByVal parent As Control, ByVal msg As String)
			MyBase.New(parent, msg)

		End Sub
		Public Overrides Function GetControlTree() As UIElement
			Return ResourceUtility.GetUIElementFromXaml("OkPopup.xaml")
		End Function
		Public Overrides Sub WireUI()
			Dim fe As FrameworkElement = CType(_popup.Child, FrameworkElement)
			Dim btCaption As TextBlock = TryCast(fe.FindName("tbCaption"), TextBlock)
			If btCaption IsNot Nothing Then
				btCaption.Text = _caption
			End If
		End Sub
		Public Overrides Sub WireHandlers()
			Dim fe As FrameworkElement = CType(_popup.Child, FrameworkElement)
			Dim btAccept As Button = CType(fe.FindName("btOk"), Button)
			AddHandler btAccept.Click, AddressOf btOk_Click
		End Sub

		Private Sub btOk_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			CloseDialog()
			RaiseEvent OnOk(Me, Nothing)
		End Sub
	End Class

End Namespace
