Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Threading

Namespace AdvClientLibrary
	Public Class SLManualResetEvent
		Private _manualResetEvent As ManualResetEvent
		Public Sub New()
			_manualResetEvent = New ManualResetEvent(False)
		End Sub
		Public Sub New(ByVal initialState As Boolean)
			_manualResetEvent = New ManualResetEvent(initialState)
		End Sub
		Public ReadOnly Property CanBlock() As Boolean
			Get
				If ApplicationHelpers.IsUiThread() Then
					Return False 'we don't want to block the UI thread;
				Else
					Return True 'we are on the worker thread
				End If
			End Get
		End Property
		Public Function WaitOne() As Boolean
			If CanBlock Then
				Return _manualResetEvent.WaitOne()
			Else
				Throw New UiThreadBlockException("Can't block UI thread")
			End If
		End Function

		Public Function WaitOne(ByVal milliSeconds As Integer) As Boolean
			If CanBlock Then
				Return _manualResetEvent.WaitOne(milliSeconds)
			Else
				Throw New UiThreadBlockException("Can't block UI thread")
			End If
		End Function

		Public Function WaitOne(ByVal timeout As TimeSpan) As Boolean
			If CanBlock Then
				Return _manualResetEvent.WaitOne(timeout)
			Else
				Throw New UiThreadBlockException("Can't block UI thread")
			End If
		End Function
		Public Function [Set]() As Boolean
			Return _manualResetEvent.Set()
		End Function
		Public Function Reset() As Boolean
			Return _manualResetEvent.Reset()
		End Function
	End Class

	Public Class UiThreadBlockException
		Inherits Exception
		Public Sub New()
			MyBase.New()
		End Sub
		Public Sub New(ByVal message As String)
			MyBase.New(message)
		End Sub
		Public Sub New(ByVal message As String, ByVal innerException As Exception)
			MyBase.New(message, innerException)
		End Sub
	End Class
End Namespace