Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Reflection
Imports System.IO
Imports System.Windows.Resources
Imports System.Xml
Imports System.Xml.Linq
Imports System.Windows.Markup

Namespace AdvClientLibrary
	Public Class ResourceUtility
		Public Shared Function GetAssembly(ByVal assemblyName As String, ByVal packageStream As Stream) As System.Reflection.Assembly
			Dim srInfo As StreamResourceInfo = Application.GetResourceStream(New StreamResourceInfo(packageStream, "application/binary"), New Uri(assemblyName, UriKind.Relative))
			Return GetAssembly(srInfo.Stream)
		End Function

		Public Shared Function GetAssembly(ByVal assemblyStream As Stream) As System.Reflection.Assembly
			Dim assemblyPart As New AssemblyPart()
			Return assemblyPart.Load(assemblyStream)
		End Function

		Public Shared Function GetXmlDocument(ByVal xmlStream As Stream) As XElement
			Dim reader As XmlReader = XmlReader.Create(xmlStream)
			Dim element As XElement = XElement.Load(reader)
			Return element
		End Function
		Public Shared Function GetXmlDocument(ByVal fileName As String, ByVal packageStream As Stream) As XElement
			Dim rs As Stream = GetStream(fileName, "application/xml", packageStream)
			Dim reader As XmlReader = XmlReader.Create(rs)
			Dim element As XElement = XElement.Load(reader)
			Return element
		End Function

		Public Shared Function GetStream(ByVal fileName As String, ByVal mimeType As String, ByVal packageStream As Stream) As Stream
			Dim sri As New StreamResourceInfo(packageStream, mimeType)
			Return Application.GetResourceStream(sri, New Uri(fileName, UriKind.Relative)).Stream
		End Function
		Public Shared Function GetXmlDocumentFromXap(ByVal fileName As String) As XElement
			Dim settings As New XmlReaderSettings()
			settings.XmlResolver = New XmlXapResolver()
			Dim reader As XmlReader = XmlReader.Create(fileName)
			Dim element As XElement = XElement.Load(reader)
			Return element
		End Function
		'gets the UIElement from the default package
		Public Shared Function GetUIElementFromXaml(ByVal xamlFileName As String) As UIElement
			Dim streamInfo As StreamResourceInfo = Application.GetResourceStream(New Uri(xamlFileName, UriKind.Relative))
			Dim xaml As String = New StreamReader(streamInfo.Stream).ReadToEnd()
			Dim uiElement As UIElement = Nothing
			Try
				uiElement = CType(XamlReader.Load(xaml), UIElement)
			Catch
				Throw New SLApplicationException(String.Format("Can't create UIElement from {0}", xamlFileName))
			End Try
			Return uiElement
		End Function
	End Class

End Namespace

