'CAUTION:This group of classes will be used on the Silverlight Client also
'so, please make sure of the compatibility at the source code level

Imports Microsoft.VisualBasic
Imports System
Imports System.Text
Imports System.Xml.Serialization
Imports System.IO

Namespace TcpMessages
	Friend Class SocketBuffer
		Public Const BUFFERSIZE As Integer = 1024
		Protected _buffer() As Byte
		Protected _offset As Integer = 0
		Public Sub New()
			_buffer = New Byte(BUFFERSIZE - 1){}
		End Sub
		Public Sub New(ByVal size As Integer)
			_buffer = New Byte(size - 1){}
		End Sub
		Public Property Buffer() As Byte()
			Get
				Return _buffer
			End Get
			Set(ByVal value As Byte())
				_buffer = value
			End Set
		End Property
		'offset will allways indicate the length of the buffer that is filled
		Public Property Offset() As Integer
			Get
				Return _offset
			End Get
			Set(ByVal value As Integer)
				_offset = value
			End Set
		End Property

		Public ReadOnly Property Remaining() As Integer
			Get
				Return _buffer.Length - _offset
			End Get
		End Property
	End Class

	Friend Class PolicyReceiveBuffer
		Inherits SocketBuffer
		Public Shared ReadOnly PolicyRequest As String = "<policy-file-request/>"
		Public Sub New()
			MyBase.New()
		End Sub
		Public Sub New(ByVal size As Integer)
			MyBase.New(size)

		End Sub
		Public Function IsMessageReceived() As Boolean
			Dim str As String = Encoding.UTF8.GetString(_buffer, 0, _offset)
			If String.Compare(PolicyRequest, str, True) = 0 Then
				Return True
			End If
			Return False
		End Function
	End Class
End Namespace
