Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Net
Imports System.Net.Sockets
Imports System.IO

Namespace AdvPolicyServer
	Friend Class TcpPolicyServer
		Private _listener As Socket
		Private _policyBuffer() As Byte
		Public Shared ReadOnly PolicyFileName As String = "clientaccesspolicy.xml"
		Private _socketAcceptArgs As New SocketAsyncEventArgs()
		Public Sub New()
			Console.WriteLine(System.Environment.CommandLine)
			Dim fs As New FileStream(TcpPolicyServer.PolicyFileName, FileMode.Open)
			_policyBuffer = New Byte(fs.Length - 1){}
			fs.Read(_policyBuffer, 0, _policyBuffer.Length)
			AddHandler _socketAcceptArgs.Completed, AddressOf AcceptAsyncCallback
		End Sub
		Public Sub Start(ByVal port As Integer)
			'read the policy file into the buffer
			Dim ipHostInfo As IPHostEntry = Dns.GetHostEntry(Dns.GetHostName())
			'Should be within the port range of 4502-4532
			Dim localEndPoint As New IPEndPoint(IPAddress.Any, port)

			_listener = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)

			' Bind the socket to the local endpoint and listen for incoming connections.
			Try
				_listener.Bind(localEndPoint)
				_listener.Listen(50)
				AcceptAsync()
			Catch e As Exception
				Throw New AppServerException("Can't start policy server", e)
			End Try
		End Sub

		Public Sub [Stop]()
			_listener.Close()
		End Sub
		Private Sub AcceptAsync()
			AcceptAsync(_socketAcceptArgs)
		End Sub

		Private Sub AcceptAsync(ByVal socketAcceptArgs As SocketAsyncEventArgs)

			If (Not _listener.AcceptAsync(socketAcceptArgs)) Then
				AcceptAsyncCallback(socketAcceptArgs.AcceptSocket, socketAcceptArgs)
			End If
		End Sub

		Private Sub AcceptAsyncCallback(ByVal sender As Object, ByVal e As SocketAsyncEventArgs)
			If e.SocketError = SocketError.Success Then
				Console.WriteLine("Connection accepted...")
				Dim con As New TcpClientConnection(e.AcceptSocket, Me._policyBuffer)
				con.ReceiveAsync()
			End If
			'the following is necessary for reuse of the _socketAcceptArgs
			e.AcceptSocket = Nothing
			'schedule a new accept request
			AcceptAsync()
		End Sub
	End Class
End Namespace
